using System;
using System.Collections.Generic;
using System.Text;

namespace cc.breeze
{
    public abstract class Observable
    {
        public void addObserver(IObserver observer)
        {
            Observers.Add(observer);
        }

        public void deleteObserver(IObserver observer)
        {
            Observers.Remove(observer);
        }

        public void notifyObserver()
        {
            foreach (IObserver observer in Observers)
            {
                observer.update(this);
            }
        }

        protected List<IObserver> Observers
        {
            get { return observers_; }
        }

        private List<IObserver> observers_ = new List<IObserver>();

    }
}
